Redmine - Feature #16006

Include attachments in forum post notifications
2014-02-01 20:40 - T. Hauptman

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Email notifications Estimated time: 0.00 hour
Target version: 4.2.0

Resolution: Fixed

Description

The send_notification is called on message creation, before attachments are added. In my case, | need links to attachments to be
sent in the notification email.

My app/views/mailer/message_posted.text.erb do do this is:

<%= @message.content %>

<% if @message.attachments.any? -%>

———<%= (:label_attachment_plural) .ljust (37, '-') %>

<% (@message.attachments.each do |attachment| -%>

<%$=attachment.filename%$>: <%=send (:named_attachment_path, attachment, attachment.filename, :only_pa
th=>false) %> (<%= number_to_human_size (attachment.filesize) %>)

<% end —-%>

<% end —-%>

<%= @author.firstname + " " + @author.lastname + " - "+ @author.mail %>

If the forum message is created by an incoming email (with attachments) then no attachements are shown in outgoing notifications. If
the forum message is created via the web form, the attachments are shown.

| fixed this by changing the send_notification trigger to after_commit. Patch attached.

Related issues:
Related to Redmine - Patch #1616: Allow email to create and reply to forum me... New 2008-07-10
Related to Redmine - Feature #33002: Include attachments in news post notific... Closed

Associated revisions

Revision 19506 - 2020-02-11 03:34 - Go MAEDA

Include attachments in forum post notifications (#16006).

Patch by Yuichi HARADA.

History

#1 - 2014-02-28 08:50 - Toshi MARUYAMA

- Category set to Email notifications

#2 - 2014-02-28 08:52 - Toshi MARUYAMA

- Tracker changed from Patch to Defect

#3 - 2014-02-28 08:55 - Toshi MARUYAMA

- Tracker changed from Defect to Patch

#4 - 2014-02-28 08:55 - Toshi MARUYAMA

- Related to Patch #1616: Allow email to create and reply to forum messages added

#5 - 2019-10-29 06:36 - Yuichi HARADA

- File forum_notification_include_attachments.png added
- File 16006 _forum_notification_include_attachments.patch added

T. Hauptman wrote:
| fixed this by changing the send_notification trigger to after_commit.
Already improved by source:trunk/app/models/message.rb@17588#L.48 . However, the attachments are not included in forum post notification.
| created a patch to include attachments in forum post notification.
forum_notification_include_attachments.png

#6 - 2019-10-30 10:30 - Go MAEDA

- Target version set to Candidate for next major release

#7 - 2019-12-19 13:08 - Go MAEDA
- File no-attachment-in-reply@2x.png added

Thank you for posting the patch. | tried out the patch but | am experiencing a problem that attachments are included only when a topic is created. No
attachments information is in a notification when a reply is added.

<redmne@example.net> <dlopper@somenet.joo>
<redmine @example.net> <ismith@somenet.foo>
Replles (1) Received Thursday, 19 Dec 2019 9:03:29 PM

From <redmine@example.net>
To <admin@somenet.foo>
Attaching lenna.jpg Subject [eCookbook - Help - msg10] RE: test message 2102

RE: test message 2102 - Added by Redmine Admin|

# lenna.jpg (19.9 KB) 4 HTML Plain Text Source

eCookbook - Help: RE: test message 2102

Redmine Admin

Attaching lenna.jpg

You have received this notification because you have either subscribed to it,
To change your notification preferences, please click here: http://hostname/]

#8 - 2019-12-26 01:56 - Yuichi HARADA
- File attachment-in-reply.png added

Go MAEDA wrote:
Thank you for posting the patch. | tried out the patch but | am experiencing a problem that attachments are included only when a topic is created.

No attachments information is in a notification when a reply is added.

It cannot be reproduced. Attachments information is in a notification when a reply is added.
https://www.redmine.org/projects/redmine/repository/svn/revisions/17588/entry/trunk/app/models/message.rb#L48

attachment-in-reply.png

#9 - 2020-01-03 09:26 - Go MAEDA

| still see the problem when adding a reply.

| found that container_type and container_id have not been set to the attachment when sending notifications. Those values are set after the delivery is
finished. So, @message.attachments.any? in app/views/mailer/message_posted.html.erb returns false when generating notification emails.

[ActiveJob] Enqueued ActionMailer::DeliveryJob (Job ID: ce613aa3-4241-4bc4-b59d-009475839967) to Inline (mailer
s) with arguments: "Mailer", "message_posted", "deliver_now", #<GlobalID:0x00007ff1b32ac090 @uri=#<URI::GID gi
d://redmine-app/User/1>>, #<GlobalID:0x00007ff1b0f1b680 Quri=#<URI::GID gid://redmine-app/Message/9>>
Attachment Load (0.3ms) SELECT "attachments".* FROM "attachments" WHERE "attachments"."id" = ? AND "attach
ments"."digest" = ? LIMIT °? [["id", 291, ["digest", "632a392aflde2e3ded4d8b5ad62da7275550ee0004cdf9f54fa3del5¢c
d28d0aac"], ["LIMIT", 111
(1.0ms) begin transaction
CACHE User Load (0.0ms) SELECT "users".* FROM "users" WHERE "users"."type" IN ('User', 'AnonymousUser') AN
D "users"."id" = ? LIMIT ? [["id", 1], ["LIMIT", 111

Attachment Update (l1.lms) UPDATE "attachments" SET "container_id" = ?, "description" = ?, "container_type"
= ? WHERE "attachments"."id" = ? [["container_id", 9], ["description", ""], ["container_type", "Message"], ["
id", 2911

(1.2ms) commit transaction

#10 - 2020-01-23 06:08 - Yuichi HARADA

- File 16006_forum_notification _include_attachments_v2.patch added

Go MAEDA wrote:

| still see the problem when adding a reply.

Perhaps | think that Message's callback method after_create_commit ( Message#send_notification ) fired before saving the attachments.
Add the following patch to 16006_forum_notification_include attachments.patch .

diff --git a/app/controllers/messages_controller.rb b/app/controllers/messages_controller.rb
index bbc6a35d4..2a0e341b6 100644
--— a/app/controllers/messages_controller.rb
+++ b/app/controllers/messages_controller.rb
@@ -77,10 +77,10 Q@ class MessagesController < ApplicationController
@reply.author = User.current
@reply.board = @board
@Qreply.safe_attributes = params[:reply]
+ @reply.save_attachments (params|[:attachments])
@topic.children << (@reply
if !@reply.new_record?
call_hook (:controller_messages_reply_after_save, { :params => params, :message => (@reply})
= attachments = Attachment.attach_files (Qreply, params|[:attachments])
render_attachment_warning_if_ needed (Qreply)

end
flash[:notice] = 1l(:notice_successful_update)
@@ -91,12 +91,14 Q@@ class MessagesController < ApplicationController
def edit

(render_403; return false) unless (@message.editable_by? (User.current)
@message.safe_attributes = params][:message]
= if request.post? && @message.save
= attachments = Attachment.attach_files (@message, params|:attachments])
= render_attachment_warning_if_ needed (@message)
flash[:notice] = 1l (:notice_successful_update)
@message.reload
redirect_to board _message_path (@message.board, @message.root, :r => (@message.parent_id && @message.id)

)
+ if request.post?
+ @message.save_attachments (params|[:attachments])
+ if @message.save
+ render_attachment_warning_if_ needed (@message)
+ flash[:notice] = 1l(:notice_successful_update)
+ @message.reload
+ redirect_to board_message_path (@message.board, @message.root, :r => (@message.parent_id && @message.i
d))
+ end

end

end
#11 - 2020-01-30 09:19 - Go MAEDA
Yuichi HARADA wrote:
Perhaps | think that Message's callback method after_create_commit ( Message#send_notification ) fired before saving the attachments.
Add the following patch to 16006_forum_noatification_include_attachments.patch .
Thank you for updating the patch. The latest patch works fine.

However, it may insert an orphaned row in the attachments table if Redmine fails to save a Message object for some reason. A possible cause is
validation error when saving the Message object.

The following is an example of an orphaned row. Since Redmine failed to save a Message object, container_id and container_type of the Attachment
object is nil.

[2] pry(main)> Attachment.last

2025-07-02 4/6


https://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/message.rb#L126
https://www.redmine.org/attachments/24241
https://www.redmine.org/projects/redmine/repository/entry/trunk/app/models/message.rb#L126
https://www.redmine.org/attachments/24241

Attachment Load (0.3ms) SELECT "attachments".* FROM "attachments" ORDER BY "attachments"."id" DESC LIMIT *?

[["LIMIT", 1]]
=> #<Attachment:0x00007£ffa37fa58f0
id: 28,

container_id: nil,

container_type: nil,

filename: "lenna.Jjpg",

disk_filename: "200130122359_1lenna. jpg",
filesize: 20401,

content_type: "image/jpeg",

digest: "632a392aflde2e3de4d8b5ad62da7275550ee0004cdf9f54fa3de05cd28d0aac",
downloads: O,

author_id: 1,

created_on: Thu, 30 Jan 2020 08:06:16 UTC +00:00,
description: nil,

disk_directory: "2020/01">

#12 - 2020-02-06 06:45 - Yuichi HARADA
Go MAEDA wrote:

However, it may insert an orphaned row in the attachments table if Redmine fails to save a Message object for some reason. A possible cause is
validation error when saving the Message object.

The following is an example of an orphaned row. Since Redmine failed to save a Message object, container_id and container_type of the
Attachment object is nil.

(-]

Thank you for pointing out.
However, | think running the rake task redmine:attachments:prune on a regular basis should solve it.

#13 - 2020-02-06 09:05 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0
Yuichi HARADA wrote:

Go MAEDA wrote:

However, it may insert an orphaned row in the attachments table if Redmine fails to save a Message object for some reason. A possible
cause is validation error when saving the Message object.

The following is an example of an orphaned row. Since Redmine failed to save a Message object, container_id and container_type of the
Attachment object is nil.

(-]

Thank you for pointing out.
However, | think running the rake task redmine:attachments:prune on a regular basis should solve it.

You are right and | was wrong. Such orphaned attachments may also be created when attaching files to issues and the orphaned files are treated by
rake redmine:attachments:prune. So, the patch doesn't have to consider the case and your patch

16006_forum_notification_include_attachments_v2.patch can be merged into the trunk as is.

Now | am setting the target version to 4.2.0.

#14 - 2020-02-11 03:34 - Go MAEDA

- Tracker changed from Patch to Feature

- Subject changed from Forum post notification does not include attachments to Include attachments in forum post notifications
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#15 - 2020-02-11 03:35 - Go MAEDA

- Status changed from New to Closed
https://www.redmine.org/attachments/24649

#16 - 2020-02-14 01:29 - Go MAEDA

- Related to Feature #33002: Include attachments in news post notifications added

Files

notify.patch 1.04 KB 2014-02-01 T. Hauptman
forum_notification_include_attachments.png 200 KB 2019-10-29 Yuichi HARADA
16006_forum_notification_include_attachments.patch 3.08 KB 2019-10-29 Yuichi HARADA
no-attachment-in-reply@2x.png 91 KB 2019-12-19 Go MAEDA
attachment-in-reply.png 370 KB 2019-12-26 Yuichi HARADA
16006_forum_notification_include_attachments_v2.patch 4.76 KB 2020-01-23 Yuichi HARADA
